#Simple PWM Motor Speed Control
from machine import Pin
from machine import ADC
from rotary import Rotary
import time
import math

#PWM
motor = machine.PWM(machine.Pin(15)) #Motor Speed PWM pin
motor.freq(1000) #Frequency of PWM

#ROTARY ENCODER
rotary = Rotary(18,17,19) #DT (Direction), CK(Clock),SW(Switch)
note = 60 #Starting MIDI Note
step = 1 #Step Size

#PWM CONVERSION noteUES
k = 4454 #Constant (change to your own noteue)
a = 0.002 #Power (change to your own noteue)


def rotary_changed(change): #Detect changes in the rotary encoder
    global note, step
    if change == Rotary.ROT_CW: #If rotated clockwise
        note = note + step #Add step noteue to current noteue
    elif change == Rotary.ROT_CCW: #If rotated counter-clockwise
        note = note - step #Remove step noteue from current noteue
    elif change == Rotary.SW_PRESS: #If button pressed
        print('Pressed') 
    elif change == Rotary.SW_RELEASE: #If Button released
        print('Released')

def motor_Speed():
    global note, k, a
    
    freq = pow(2, ((note-69)/12)) * 440 #MIDI to Frequency
    duty = k * math.exp(a * freq) #Frequency to Duty
    motor.duty_u16(int(duty)) #PWM duty noteue from Rotary encoder
    print('MIDI Note is ' + str(note) + ' PWM Duty is ' + str(int(duty)))     
    time.sleep(0.2) #0.2 second frame size
    
rotary.add_handler(rotary_changed) #Handler for rotary encoder

while True:
    motor_Speed() #Run the motor speed function